<?php

namespace Sisteract;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'SisterRead2Input_Type' => '\\Sisteract\\StructType\\SisterRead2Input_Type',
            'SisterRead2Return_Type' => '\\Sisteract\\StructType\\SisterRead2Return_Type',
            'GetEstrattoMappaIn_Type' => '\\Sisteract\\StructType\\GetEstrattoMappaIn_Type',
            'UtenteSisterBean_Type' => '\\Sisteract\\StructType\\UtenteSisterBean_Type',
            'Session_Type' => '\\Sisteract\\StructType\\Session_Type',
            'ParametriEstrattoMappa_Type' => '\\Sisteract\\StructType\\ParametriEstrattoMappa_Type',
            'GetEstrattoMappaOut_Type' => '\\Sisteract\\StructType\\GetEstrattoMappaOut_Type',
            'ReturnDownloadVisura_Type' => '\\Sisteract\\StructType\\ReturnDownloadVisura_Type',
            'GetFormalitaIn_Type' => '\\Sisteract\\StructType\\GetFormalitaIn_Type',
            'ParametriStaccoFormalitaConservatoria_Type' => '\\Sisteract\\StructType\\ParametriStaccoFormalitaConservatoria_Type',
            'GetFormalitaOut_Type' => '\\Sisteract\\StructType\\GetFormalitaOut_Type',
            'GetNotaIn_Type' => '\\Sisteract\\StructType\\GetNotaIn_Type',
            'ParametriRichiestaNota_Type' => '\\Sisteract\\StructType\\ParametriRichiestaNota_Type',
            'ConservatoriaBean_Type' => '\\Sisteract\\StructType\\ConservatoriaBean_Type',
            'RestrizioneImmobileBean_Type' => '\\Sisteract\\StructType\\RestrizioneImmobileBean_Type',
            'RestrizionePersoneBean_Type' => '\\Sisteract\\StructType\\RestrizionePersoneBean_Type',
            'GetNotaOut_Type' => '\\Sisteract\\StructType\\GetNotaOut_Type',
            'GetTitoloConservatoriaIn_Type' => '\\Sisteract\\StructType\\GetTitoloConservatoriaIn_Type',
            'ParametriStaccoTitoloConservatoria_Type' => '\\Sisteract\\StructType\\ParametriStaccoTitoloConservatoria_Type',
            'GetTitoloConservatoriaOut_Type' => '\\Sisteract\\StructType\\GetTitoloConservatoriaOut_Type',
            'GetRichiestaSchedaCatastaleImmobiliIn_Type' => '\\Sisteract\\StructType\\GetRichiestaSchedaCatastaleImmobiliIn_Type',
            'ParametriRichiestaVisuraImmobili_Type' => '\\Sisteract\\StructType\\ParametriRichiestaVisuraImmobili_Type',
            'GetRichiestaSchedaCatastaleImmobiliOut_Type' => '\\Sisteract\\StructType\\GetRichiestaSchedaCatastaleImmobiliOut_Type',
            'ReturnDownloadVisuraImmobili_Type' => '\\Sisteract\\StructType\\ReturnDownloadVisuraImmobili_Type',
            'GetRichiestaVisuraImmobiliIn_Type' => '\\Sisteract\\StructType\\GetRichiestaVisuraImmobiliIn_Type',
            'GetRichiestaVisuraImmobiliOut_Type' => '\\Sisteract\\StructType\\GetRichiestaVisuraImmobiliOut_Type',
            'GetRichiestaSchedaCatastaleSoggettoIn_Type' => '\\Sisteract\\StructType\\GetRichiestaSchedaCatastaleSoggettoIn_Type',
            'ParametriRichiestaVisuraSoggetto_Type' => '\\Sisteract\\StructType\\ParametriRichiestaVisuraSoggetto_Type',
            'GetRichiestaSchedaCatastaleSoggettoOut_Type' => '\\Sisteract\\StructType\\GetRichiestaSchedaCatastaleSoggettoOut_Type',
            'ReturnDownloadVisuraSoggetto_Type' => '\\Sisteract\\StructType\\ReturnDownloadVisuraSoggetto_Type',
            'GetRichiestaVisuraSoggettoIn_Type' => '\\Sisteract\\StructType\\GetRichiestaVisuraSoggettoIn_Type',
            'GetRichiestaVisuraSoggettoOut_Type' => '\\Sisteract\\StructType\\GetRichiestaVisuraSoggettoOut_Type',
            'GetVisuraByTicketIn_Type' => '\\Sisteract\\StructType\\GetVisuraByTicketIn_Type',
            'GetVisuraByTicketOut_Type' => '\\Sisteract\\StructType\\GetVisuraByTicketOut_Type',
            'GetElencoFormalitaIn_Type' => '\\Sisteract\\StructType\\GetElencoFormalitaIn_Type',
            'ParametriElencoFormalitaConservatoria_Type' => '\\Sisteract\\StructType\\ParametriElencoFormalitaConservatoria_Type',
            'ParametriRestrizioneFormalita_Type' => '\\Sisteract\\StructType\\ParametriRestrizioneFormalita_Type',
            'GetElencoFormalitaOut_Type' => '\\Sisteract\\StructType\\GetElencoFormalitaOut_Type',
            'ReturnElencoFormalitaList_Type' => '\\Sisteract\\StructType\\ReturnElencoFormalitaList_Type',
            'Formalita_Type' => '\\Sisteract\\StructType\\Formalita_Type',
            'ComuniBean_Type' => '\\Sisteract\\StructType\\ComuniBean_Type',
            'CorrelazioneFormalita_Type' => '\\Sisteract\\StructType\\CorrelazioneFormalita_Type',
            'RiferimentoFormalita_Type' => '\\Sisteract\\StructType\\RiferimentoFormalita_Type',
            'GetElencoFormalitaImmobileIn_Type' => '\\Sisteract\\StructType\\GetElencoFormalitaImmobileIn_Type',
            'GetElencoFormalitaImmobileOut_Type' => '\\Sisteract\\StructType\\GetElencoFormalitaImmobileOut_Type',
            'GetElencoFormalitaImmobilePdfIn_Type' => '\\Sisteract\\StructType\\GetElencoFormalitaImmobilePdfIn_Type',
            'GetElencoFormalitaImmobilePdfOut_Type' => '\\Sisteract\\StructType\\GetElencoFormalitaImmobilePdfOut_Type',
            'ReturnElencoFormalitaListConStampaInPDF_Type' => '\\Sisteract\\StructType\\ReturnElencoFormalitaListConStampaInPDF_Type',
            'GetElencoFormalitaPdfIn_Type' => '\\Sisteract\\StructType\\GetElencoFormalitaPdfIn_Type',
            'GetElencoFormalitaPdfOut_Type' => '\\Sisteract\\StructType\\GetElencoFormalitaPdfOut_Type',
            'GetElencoImmobiliIn_Type' => '\\Sisteract\\StructType\\GetElencoImmobiliIn_Type',
            'ParametriRichiestaElencoImmobili_Type' => '\\Sisteract\\StructType\\ParametriRichiestaElencoImmobili_Type',
            'GetElencoImmobiliOut_Type' => '\\Sisteract\\StructType\\GetElencoImmobiliOut_Type',
            'ReturnElencoImmobiliList_Type' => '\\Sisteract\\StructType\\ReturnElencoImmobiliList_Type',
            'ImmobileDaElencoBean_Type' => '\\Sisteract\\StructType\\ImmobileDaElencoBean_Type',
            'GetRicercaConservatoriaImmobileIn_Type' => '\\Sisteract\\StructType\\GetRicercaConservatoriaImmobileIn_Type',
            'ParametriRicercaImmobiliIdentificativo_Type' => '\\Sisteract\\StructType\\ParametriRicercaImmobiliIdentificativo_Type',
            'ParametriRicercaImmobileConservatoriaBean_Type' => '\\Sisteract\\StructType\\ParametriRicercaImmobileConservatoriaBean_Type',
            'GetRicercaConservatoriaImmobileOut_Type' => '\\Sisteract\\StructType\\GetRicercaConservatoriaImmobileOut_Type',
            'GetElencoIntestatiIn_Type' => '\\Sisteract\\StructType\\GetElencoIntestatiIn_Type',
            'ParametriRichiestaElencoIntestati_Type' => '\\Sisteract\\StructType\\ParametriRichiestaElencoIntestati_Type',
            'GetElencoIntestatiOut_Type' => '\\Sisteract\\StructType\\GetElencoIntestatiOut_Type',
            'ReturnElencoIntestatiList_Type' => '\\Sisteract\\StructType\\ReturnElencoIntestatiList_Type',
            'IntestatiDaElencoBean_Type' => '\\Sisteract\\StructType\\IntestatiDaElencoBean_Type',
            'GetRicercaImmobiliDaListaIndirizziIn_Type' => '\\Sisteract\\StructType\\GetRicercaImmobiliDaListaIndirizziIn_Type',
            'ParametriRicercaImmobiliIndirizzo_Type' => '\\Sisteract\\StructType\\ParametriRicercaImmobiliIndirizzo_Type',
            'GetRicercaImmobiliDaListaIndirizziOut_Type' => '\\Sisteract\\StructType\\GetRicercaImmobiliDaListaIndirizziOut_Type',
            'ReturnIdentificativoCatastaleList_Type' => '\\Sisteract\\StructType\\ReturnIdentificativoCatastaleList_Type',
            'IdentificativoCatastaleBean_Type' => '\\Sisteract\\StructType\\IdentificativoCatastaleBean_Type',
            'IdentificativoCatastaleTerreniBean_Type' => '\\Sisteract\\StructType\\IdentificativoCatastaleTerreniBean_Type',
            'GetRicercaImmobiliIdentificativoIn_Type' => '\\Sisteract\\StructType\\GetRicercaImmobiliIdentificativoIn_Type',
            'GetRicercaImmobiliIdentificativoOut_Type' => '\\Sisteract\\StructType\\GetRicercaImmobiliIdentificativoOut_Type',
            'GetRicercaImmobiliIndirizzoNoToponimoIn_Type' => '\\Sisteract\\StructType\\GetRicercaImmobiliIndirizzoNoToponimoIn_Type',
            'ParametriRicercaImmobiliIndirizzoNoToponimo_Type' => '\\Sisteract\\StructType\\ParametriRicercaImmobiliIndirizzoNoToponimo_Type',
            'GetRicercaImmobiliIndirizzoNoToponimoOut_Type' => '\\Sisteract\\StructType\\GetRicercaImmobiliIndirizzoNoToponimoOut_Type',
            'ReturnIndirizziList_Type' => '\\Sisteract\\StructType\\ReturnIndirizziList_Type',
            'IndirizziBean_Type' => '\\Sisteract\\StructType\\IndirizziBean_Type',
            'GetRicercaImmobiliIndirizzoToponimoIn_Type' => '\\Sisteract\\StructType\\GetRicercaImmobiliIndirizzoToponimoIn_Type',
            'ParametriRicercaImmobiliIndirizzoToponimo_Type' => '\\Sisteract\\StructType\\ParametriRicercaImmobiliIndirizzoToponimo_Type',
            'GetRicercaImmobiliIndirizzoToponimoOut_Type' => '\\Sisteract\\StructType\\GetRicercaImmobiliIndirizzoToponimoOut_Type',
            'GetRicercaConservatoriaPersonaFisicaIn_Type' => '\\Sisteract\\StructType\\GetRicercaConservatoriaPersonaFisicaIn_Type',
            'ParametriRicercaPersonaFisicaBean_Type' => '\\Sisteract\\StructType\\ParametriRicercaPersonaFisicaBean_Type',
            'ParametriRicercaPersonaFisicaConservatoriaBean_Type' => '\\Sisteract\\StructType\\ParametriRicercaPersonaFisicaConservatoriaBean_Type',
            'GetRicercaConservatoriaPersonaFisicaOut_Type' => '\\Sisteract\\StructType\\GetRicercaConservatoriaPersonaFisicaOut_Type',
            'ReturnPersoneFisicheList_Type' => '\\Sisteract\\StructType\\ReturnPersoneFisicheList_Type',
            'PersoneFisicheBean_Type' => '\\Sisteract\\StructType\\PersoneFisicheBean_Type',
            'GetRicercaNazionalePersonaFisicaIn_Type' => '\\Sisteract\\StructType\\GetRicercaNazionalePersonaFisicaIn_Type',
            'GetRicercaNazionalePersonaFisicaOut_Type' => '\\Sisteract\\StructType\\GetRicercaNazionalePersonaFisicaOut_Type',
            'GetRicercaConservatoriaPersonaGiuridicaIn_Type' => '\\Sisteract\\StructType\\GetRicercaConservatoriaPersonaGiuridicaIn_Type',
            'ParametriRicercaPersonaGiuridicaBean_Type' => '\\Sisteract\\StructType\\ParametriRicercaPersonaGiuridicaBean_Type',
            'ParametriRicercaPersonaGiuridicaConservatoriaBean_Type' => '\\Sisteract\\StructType\\ParametriRicercaPersonaGiuridicaConservatoriaBean_Type',
            'GetRicercaConservatoriaPersonaGiuridicaOut_Type' => '\\Sisteract\\StructType\\GetRicercaConservatoriaPersonaGiuridicaOut_Type',
            'ReturnPersoneGiuridicheList_Type' => '\\Sisteract\\StructType\\ReturnPersoneGiuridicheList_Type',
            'PersoneGiuridicheBean_Type' => '\\Sisteract\\StructType\\PersoneGiuridicheBean_Type',
            'GetRicercaNazionalePersonaGiuridicaIn_Type' => '\\Sisteract\\StructType\\GetRicercaNazionalePersonaGiuridicaIn_Type',
            'GetRicercaNazionalePersonaGiuridicaOut_Type' => '\\Sisteract\\StructType\\GetRicercaNazionalePersonaGiuridicaOut_Type',
            'GetListaComuniIn_Type' => '\\Sisteract\\StructType\\GetListaComuniIn_Type',
            'ParametriRicercaComuni_Type' => '\\Sisteract\\StructType\\ParametriRicercaComuni_Type',
            'GetListaComuniOut_Type' => '\\Sisteract\\StructType\\GetListaComuniOut_Type',
            'ReturnProvincieList_Type' => '\\Sisteract\\StructType\\ReturnProvincieList_Type',
            'ProvinciaTerreniFabbricatiBean_Type' => '\\Sisteract\\StructType\\ProvinciaTerreniFabbricatiBean_Type',
            'GetRichiestaTipiVisuraImmobileIn_Type' => '\\Sisteract\\StructType\\GetRichiestaTipiVisuraImmobileIn_Type',
            'ParametriRichiestaTipiVisuraImmobile_Type' => '\\Sisteract\\StructType\\ParametriRichiestaTipiVisuraImmobile_Type',
            'GetRichiestaTipiVisuraImmobileOut_Type' => '\\Sisteract\\StructType\\GetRichiestaTipiVisuraImmobileOut_Type',
            'ReturnTipoVisuraImmobileList_Type' => '\\Sisteract\\StructType\\ReturnTipoVisuraImmobileList_Type',
            'ApriSessioneIn_Type' => '\\Sisteract\\StructType\\ApriSessioneIn_Type',
            'ApriSessioneOut_Type' => '\\Sisteract\\StructType\\ApriSessioneOut_Type',
            'GetComuniIn_Type' => '\\Sisteract\\StructType\\GetComuniIn_Type',
            'GetComuniOut_Type' => '\\Sisteract\\StructType\\GetComuniOut_Type',
            'GetComuniCatastaliIn_Type' => '\\Sisteract\\StructType\\GetComuniCatastaliIn_Type',
            'GetComuniCatastaliOut_Type' => '\\Sisteract\\StructType\\GetComuniCatastaliOut_Type',
            'GetComuniConservatoriaIn_Type' => '\\Sisteract\\StructType\\GetComuniConservatoriaIn_Type',
            'GetComuniConservatoriaOut_Type' => '\\Sisteract\\StructType\\GetComuniConservatoriaOut_Type',
            'GetConservatorieIn_Type' => '\\Sisteract\\StructType\\GetConservatorieIn_Type',
            'GetConservatorieOut_Type' => '\\Sisteract\\StructType\\GetConservatorieOut_Type',
            'GetProvincieIn_Type' => '\\Sisteract\\StructType\\GetProvincieIn_Type',
            'GetProvincieOut_Type' => '\\Sisteract\\StructType\\GetProvincieOut_Type',
            'ProvincieBean_Type' => '\\Sisteract\\StructType\\ProvincieBean_Type',
            'GetSezioniIn_Type' => '\\Sisteract\\StructType\\GetSezioniIn_Type',
            'GetSezioniOut_Type' => '\\Sisteract\\StructType\\GetSezioniOut_Type',
            'SezioniBean_Type' => '\\Sisteract\\StructType\\SezioniBean_Type',
            'GetToponimiIn_Type' => '\\Sisteract\\StructType\\GetToponimiIn_Type',
            'GetToponimiOut_Type' => '\\Sisteract\\StructType\\GetToponimiOut_Type',
            'ReturnToponimiList_Type' => '\\Sisteract\\StructType\\ReturnToponimiList_Type',
            'GetProvincieAmministrativeIn_Type' => '\\Sisteract\\StructType\\GetProvincieAmministrativeIn_Type',
            'GetProvincieAmministrativeOut_Type' => '\\Sisteract\\StructType\\GetProvincieAmministrativeOut_Type',
            'ListaUtentiSisterMemorizzatiIn_Type' => '\\Sisteract\\StructType\\ListaUtentiSisterMemorizzatiIn_Type',
            'ListaUtentiSisterMemorizzatiOut_Type' => '\\Sisteract\\StructType\\ListaUtentiSisterMemorizzatiOut_Type',
            'ListaVisureInArchivioIn_Type' => '\\Sisteract\\StructType\\ListaVisureInArchivioIn_Type',
            'ListaVisureInArchivioOut_Type' => '\\Sisteract\\StructType\\ListaVisureInArchivioOut_Type',
            'VisuraDaArchivio_Type' => '\\Sisteract\\StructType\\VisuraDaArchivio_Type',
            'PosizioneImmobiliVisura_Type' => '\\Sisteract\\StructType\\PosizioneImmobiliVisura_Type',
            'ComuneImmobileConConservatoria_Type' => '\\Sisteract\\StructType\\ComuneImmobileConConservatoria_Type',
            'ListaVisureInArchivioPerCodiceFiscaleIn_Type' => '\\Sisteract\\StructType\\ListaVisureInArchivioPerCodiceFiscaleIn_Type',
            'ListaVisureInArchivioPerCodiceFiscaleOut_Type' => '\\Sisteract\\StructType\\ListaVisureInArchivioPerCodiceFiscaleOut_Type',
            'ChiudiSessioneIn_Type' => '\\Sisteract\\StructType\\ChiudiSessioneIn_Type',
            'ChiudiSessioneOut_Type' => '\\Sisteract\\StructType\\ChiudiSessioneOut_Type',
            'EliminaUtenteSisterMemorizzatoIn_Type' => '\\Sisteract\\StructType\\EliminaUtenteSisterMemorizzatoIn_Type',
            'EliminaUtenteSisterMemorizzatoOut_Type' => '\\Sisteract\\StructType\\EliminaUtenteSisterMemorizzatoOut_Type',
            'MemorizzaUtenteSisterIn_Type' => '\\Sisteract\\StructType\\MemorizzaUtenteSisterIn_Type',
            'MemorizzaUtenteSisterOut_Type' => '\\Sisteract\\StructType\\MemorizzaUtenteSisterOut_Type',
            'SettaAvvertimentoBudgetIn_Type' => '\\Sisteract\\StructType\\SettaAvvertimentoBudgetIn_Type',
            'SettaAvvertimentoBudgetOut_Type' => '\\Sisteract\\StructType\\SettaAvvertimentoBudgetOut_Type',
        );
    }
}
