<?php

namespace Sisteract\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetConservatorieOut_Type StructType
 * Meta information extracted from the WSDL
 * - documentation: Uscita dall'operazione 'GetConservatorie'
 * @subpackage Structs
 */
class GetConservatorieOut_Type extends SisterRead2Return_Type
{
    /**
     * The _
     * @var \Sisteract\StructType\SisterRead2Return_Type
     */
    public $_;
    /**
     * The input
     * Meta information extracted from the WSDL
     * - documentation: Dati passati in ingresso
     * @var \Sisteract\StructType\GetConservatorieIn_Type
     */
    public $input;
    /**
     * The output
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - nillable: true
     * @var \Sisteract\StructType\ConservatoriaBean_Type[]
     */
    public $output;
    /**
     * Constructor method for GetConservatorieOut_Type
     * @uses GetConservatorieOut_Type::set_()
     * @uses GetConservatorieOut_Type::setInput()
     * @uses GetConservatorieOut_Type::setOutput()
     * @param \Sisteract\StructType\SisterRead2Return_Type $_
     * @param \Sisteract\StructType\GetConservatorieIn_Type $input
     * @param \Sisteract\StructType\ConservatoriaBean_Type[] $output
     */
    public function __construct(\Sisteract\StructType\SisterRead2Return_Type $_ = null, \Sisteract\StructType\GetConservatorieIn_Type $input = null, array $output = array())
    {
        $this
            ->set_($_)
            ->setInput($input)
            ->setOutput($output);
    }
    /**
     * Get _ value
     * @return \Sisteract\StructType\SisterRead2Return_Type|null
     */
    public function get_()
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param \Sisteract\StructType\SisterRead2Return_Type $_
     * @return \Sisteract\StructType\GetConservatorieOut_Type
     */
    public function set_(\Sisteract\StructType\SisterRead2Return_Type $_ = null)
    {
        $this->_ = $_;
        return $this;
    }
    /**
     * Get input value
     * @return \Sisteract\StructType\GetConservatorieIn_Type|null
     */
    public function getInput()
    {
        return $this->input;
    }
    /**
     * Set input value
     * @param \Sisteract\StructType\GetConservatorieIn_Type $input
     * @return \Sisteract\StructType\GetConservatorieOut_Type
     */
    public function setInput(\Sisteract\StructType\GetConservatorieIn_Type $input = null)
    {
        $this->input = $input;
        return $this;
    }
    /**
     * Get output value
     * @return \Sisteract\StructType\ConservatoriaBean_Type[]|null
     */
    public function getOutput()
    {
        return $this->output;
    }
    /**
     * This method is responsible for validating the values passed to the setOutput method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOutput method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOutputForArrayConstraintsFromSetOutput(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getConservatorieOut_TypeOutputItem) {
            // validation for constraint: itemType
            if (!$getConservatorieOut_TypeOutputItem instanceof \Sisteract\StructType\ConservatoriaBean_Type) {
                $invalidValues[] = is_object($getConservatorieOut_TypeOutputItem) ? get_class($getConservatorieOut_TypeOutputItem) : sprintf('%s(%s)', gettype($getConservatorieOut_TypeOutputItem), var_export($getConservatorieOut_TypeOutputItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The output property can only contain items of type \Sisteract\StructType\ConservatoriaBean_Type, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set output value
     * @throws \InvalidArgumentException
     * @param \Sisteract\StructType\ConservatoriaBean_Type[] $output
     * @return \Sisteract\StructType\GetConservatorieOut_Type
     */
    public function setOutput(array $output = array())
    {
        // validation for constraint: array
        if ('' !== ($outputArrayErrorMessage = self::validateOutputForArrayConstraintsFromSetOutput($output))) {
            throw new \InvalidArgumentException($outputArrayErrorMessage, __LINE__);
        }
        $this->output = $output;
        return $this;
    }
    /**
     * Add item to output value
     * @throws \InvalidArgumentException
     * @param \Sisteract\StructType\ConservatoriaBean_Type $item
     * @return \Sisteract\StructType\GetConservatorieOut_Type
     */
    public function addToOutput(\Sisteract\StructType\ConservatoriaBean_Type $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sisteract\StructType\ConservatoriaBean_Type) {
            throw new \InvalidArgumentException(sprintf('The output property can only contain items of type \Sisteract\StructType\ConservatoriaBean_Type, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->output[] = $item;
        return $this;
    }
}
