<?php

namespace Sisteract\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetSezioniOut_Type StructType
 * Meta information extracted from the WSDL
 * - documentation: Uscita dall'operazione 'GetSezioni'
 * @subpackage Structs
 */
class GetSezioniOut_Type extends SisterRead2Return_Type
{
    /**
     * The _
     * @var \Sisteract\StructType\SisterRead2Return_Type
     */
    public $_;
    /**
     * The input
     * Meta information extracted from the WSDL
     * - documentation: Dati passati in ingresso
     * @var \Sisteract\StructType\GetSezioniIn_Type
     */
    public $input;
    /**
     * The output
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Sisteract\StructType\SezioniBean_Type[]
     */
    public $output;
    /**
     * Constructor method for GetSezioniOut_Type
     * @uses GetSezioniOut_Type::set_()
     * @uses GetSezioniOut_Type::setInput()
     * @uses GetSezioniOut_Type::setOutput()
     * @param \Sisteract\StructType\SisterRead2Return_Type $_
     * @param \Sisteract\StructType\GetSezioniIn_Type $input
     * @param \Sisteract\StructType\SezioniBean_Type[] $output
     */
    public function __construct(\Sisteract\StructType\SisterRead2Return_Type $_ = null, \Sisteract\StructType\GetSezioniIn_Type $input = null, array $output = array())
    {
        $this
            ->set_($_)
            ->setInput($input)
            ->setOutput($output);
    }
    /**
     * Get _ value
     * @return \Sisteract\StructType\SisterRead2Return_Type|null
     */
    public function get_()
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param \Sisteract\StructType\SisterRead2Return_Type $_
     * @return \Sisteract\StructType\GetSezioniOut_Type
     */
    public function set_(\Sisteract\StructType\SisterRead2Return_Type $_ = null)
    {
        $this->_ = $_;
        return $this;
    }
    /**
     * Get input value
     * @return \Sisteract\StructType\GetSezioniIn_Type|null
     */
    public function getInput()
    {
        return $this->input;
    }
    /**
     * Set input value
     * @param \Sisteract\StructType\GetSezioniIn_Type $input
     * @return \Sisteract\StructType\GetSezioniOut_Type
     */
    public function setInput(\Sisteract\StructType\GetSezioniIn_Type $input = null)
    {
        $this->input = $input;
        return $this;
    }
    /**
     * Get output value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Sisteract\StructType\SezioniBean_Type[]|null
     */
    public function getOutput()
    {
        return isset($this->output) ? $this->output : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOutput method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOutput method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOutputForArrayConstraintsFromSetOutput(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getSezioniOut_TypeOutputItem) {
            // validation for constraint: itemType
            if (!$getSezioniOut_TypeOutputItem instanceof \Sisteract\StructType\SezioniBean_Type) {
                $invalidValues[] = is_object($getSezioniOut_TypeOutputItem) ? get_class($getSezioniOut_TypeOutputItem) : sprintf('%s(%s)', gettype($getSezioniOut_TypeOutputItem), var_export($getSezioniOut_TypeOutputItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The output property can only contain items of type \Sisteract\StructType\SezioniBean_Type, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set output value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Sisteract\StructType\SezioniBean_Type[] $output
     * @return \Sisteract\StructType\GetSezioniOut_Type
     */
    public function setOutput(array $output = array())
    {
        // validation for constraint: array
        if ('' !== ($outputArrayErrorMessage = self::validateOutputForArrayConstraintsFromSetOutput($output))) {
            throw new \InvalidArgumentException($outputArrayErrorMessage, __LINE__);
        }
        if (is_null($output) || (is_array($output) && empty($output))) {
            unset($this->output);
        } else {
            $this->output = $output;
        }
        return $this;
    }
    /**
     * Add item to output value
     * @throws \InvalidArgumentException
     * @param \Sisteract\StructType\SezioniBean_Type $item
     * @return \Sisteract\StructType\GetSezioniOut_Type
     */
    public function addToOutput(\Sisteract\StructType\SezioniBean_Type $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sisteract\StructType\SezioniBean_Type) {
            throw new \InvalidArgumentException(sprintf('The output property can only contain items of type \Sisteract\StructType\SezioniBean_Type, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->output[] = $item;
        return $this;
    }
}
