<?php

namespace Sisteract\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for IntestatiDaElencoBean_Type StructType
 * Meta information extracted from the WSDL
 * - documentation: Rappresenta i dati di un immobile che si ottengono da una chiamata di "elenco immobili"
 * @subpackage Structs
 */
class IntestatiDaElencoBean_Type extends AbstractStructBase
{
    /**
     * The codiceFiscale
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $codiceFiscale;
    /**
     * The cognome
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $cognome;
    /**
     * The denominazione
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $denominazione;
    /**
     * The diritti
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $diritti;
    /**
     * The natoa
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $natoa;
    /**
     * The natoil
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $natoil;
    /**
     * The nome
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $nome;
    /**
     * The quote
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $quote;
    /**
     * The sede
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $sede;
    /**
     * Constructor method for IntestatiDaElencoBean_Type
     * @uses IntestatiDaElencoBean_Type::setCodiceFiscale()
     * @uses IntestatiDaElencoBean_Type::setCognome()
     * @uses IntestatiDaElencoBean_Type::setDenominazione()
     * @uses IntestatiDaElencoBean_Type::setDiritti()
     * @uses IntestatiDaElencoBean_Type::setNatoa()
     * @uses IntestatiDaElencoBean_Type::setNatoil()
     * @uses IntestatiDaElencoBean_Type::setNome()
     * @uses IntestatiDaElencoBean_Type::setQuote()
     * @uses IntestatiDaElencoBean_Type::setSede()
     * @param string $codiceFiscale
     * @param string $cognome
     * @param string $denominazione
     * @param string $diritti
     * @param string $natoa
     * @param string $natoil
     * @param string $nome
     * @param string $quote
     * @param string $sede
     */
    public function __construct($codiceFiscale = null, $cognome = null, $denominazione = null, $diritti = null, $natoa = null, $natoil = null, $nome = null, $quote = null, $sede = null)
    {
        $this
            ->setCodiceFiscale($codiceFiscale)
            ->setCognome($cognome)
            ->setDenominazione($denominazione)
            ->setDiritti($diritti)
            ->setNatoa($natoa)
            ->setNatoil($natoil)
            ->setNome($nome)
            ->setQuote($quote)
            ->setSede($sede);
    }
    /**
     * Get codiceFiscale value
     * @return string|null
     */
    public function getCodiceFiscale()
    {
        return $this->codiceFiscale;
    }
    /**
     * Set codiceFiscale value
     * @param string $codiceFiscale
     * @return \Sisteract\StructType\IntestatiDaElencoBean_Type
     */
    public function setCodiceFiscale($codiceFiscale = null)
    {
        // validation for constraint: string
        if (!is_null($codiceFiscale) && !is_string($codiceFiscale)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codiceFiscale, true), gettype($codiceFiscale)), __LINE__);
        }
        $this->codiceFiscale = $codiceFiscale;
        return $this;
    }
    /**
     * Get cognome value
     * @return string|null
     */
    public function getCognome()
    {
        return $this->cognome;
    }
    /**
     * Set cognome value
     * @param string $cognome
     * @return \Sisteract\StructType\IntestatiDaElencoBean_Type
     */
    public function setCognome($cognome = null)
    {
        // validation for constraint: string
        if (!is_null($cognome) && !is_string($cognome)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cognome, true), gettype($cognome)), __LINE__);
        }
        $this->cognome = $cognome;
        return $this;
    }
    /**
     * Get denominazione value
     * @return string|null
     */
    public function getDenominazione()
    {
        return $this->denominazione;
    }
    /**
     * Set denominazione value
     * @param string $denominazione
     * @return \Sisteract\StructType\IntestatiDaElencoBean_Type
     */
    public function setDenominazione($denominazione = null)
    {
        // validation for constraint: string
        if (!is_null($denominazione) && !is_string($denominazione)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($denominazione, true), gettype($denominazione)), __LINE__);
        }
        $this->denominazione = $denominazione;
        return $this;
    }
    /**
     * Get diritti value
     * @return string|null
     */
    public function getDiritti()
    {
        return $this->diritti;
    }
    /**
     * Set diritti value
     * @param string $diritti
     * @return \Sisteract\StructType\IntestatiDaElencoBean_Type
     */
    public function setDiritti($diritti = null)
    {
        // validation for constraint: string
        if (!is_null($diritti) && !is_string($diritti)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($diritti, true), gettype($diritti)), __LINE__);
        }
        $this->diritti = $diritti;
        return $this;
    }
    /**
     * Get natoa value
     * @return string|null
     */
    public function getNatoa()
    {
        return $this->natoa;
    }
    /**
     * Set natoa value
     * @param string $natoa
     * @return \Sisteract\StructType\IntestatiDaElencoBean_Type
     */
    public function setNatoa($natoa = null)
    {
        // validation for constraint: string
        if (!is_null($natoa) && !is_string($natoa)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($natoa, true), gettype($natoa)), __LINE__);
        }
        $this->natoa = $natoa;
        return $this;
    }
    /**
     * Get natoil value
     * @return string|null
     */
    public function getNatoil()
    {
        return $this->natoil;
    }
    /**
     * Set natoil value
     * @param string $natoil
     * @return \Sisteract\StructType\IntestatiDaElencoBean_Type
     */
    public function setNatoil($natoil = null)
    {
        // validation for constraint: string
        if (!is_null($natoil) && !is_string($natoil)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($natoil, true), gettype($natoil)), __LINE__);
        }
        $this->natoil = $natoil;
        return $this;
    }
    /**
     * Get nome value
     * @return string|null
     */
    public function getNome()
    {
        return $this->nome;
    }
    /**
     * Set nome value
     * @param string $nome
     * @return \Sisteract\StructType\IntestatiDaElencoBean_Type
     */
    public function setNome($nome = null)
    {
        // validation for constraint: string
        if (!is_null($nome) && !is_string($nome)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nome, true), gettype($nome)), __LINE__);
        }
        $this->nome = $nome;
        return $this;
    }
    /**
     * Get quote value
     * @return string|null
     */
    public function getQuote()
    {
        return $this->quote;
    }
    /**
     * Set quote value
     * @param string $quote
     * @return \Sisteract\StructType\IntestatiDaElencoBean_Type
     */
    public function setQuote($quote = null)
    {
        // validation for constraint: string
        if (!is_null($quote) && !is_string($quote)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($quote, true), gettype($quote)), __LINE__);
        }
        $this->quote = $quote;
        return $this;
    }
    /**
     * Get sede value
     * @return string|null
     */
    public function getSede()
    {
        return $this->sede;
    }
    /**
     * Set sede value
     * @param string $sede
     * @return \Sisteract\StructType\IntestatiDaElencoBean_Type
     */
    public function setSede($sede = null)
    {
        // validation for constraint: string
        if (!is_null($sede) && !is_string($sede)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sede, true), gettype($sede)), __LINE__);
        }
        $this->sede = $sede;
        return $this;
    }
}
