<?php

namespace Sisteract\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ParametriEstrattoMappa_Type StructType
 * @subpackage Structs
 */
class ParametriEstrattoMappa_Type extends Session_Type
{
    /**
     * The codiceComune
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $codiceComune;
    /**
     * The foglio
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $foglio;
    /**
     * The formatoMappa
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $formatoMappa;
    /**
     * The interoFoglio
     * @var bool
     */
    public $interoFoglio;
    /**
     * The mappeLimitrofe
     * @var bool
     */
    public $mappeLimitrofe;
    /**
     * The particella
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $particella;
    /**
     * The provincia
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $provincia;
    /**
     * The sezione
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $sezione;
    /**
     * Constructor method for ParametriEstrattoMappa_Type
     * @uses ParametriEstrattoMappa_Type::setCodiceComune()
     * @uses ParametriEstrattoMappa_Type::setFoglio()
     * @uses ParametriEstrattoMappa_Type::setFormatoMappa()
     * @uses ParametriEstrattoMappa_Type::setInteroFoglio()
     * @uses ParametriEstrattoMappa_Type::setMappeLimitrofe()
     * @uses ParametriEstrattoMappa_Type::setParticella()
     * @uses ParametriEstrattoMappa_Type::setProvincia()
     * @uses ParametriEstrattoMappa_Type::setSezione()
     * @param string $codiceComune
     * @param string $foglio
     * @param string $formatoMappa
     * @param bool $interoFoglio
     * @param bool $mappeLimitrofe
     * @param string $particella
     * @param string $provincia
     * @param string $sezione
     */
    public function __construct($codiceComune = null, $foglio = null, $formatoMappa = null, $interoFoglio = null, $mappeLimitrofe = null, $particella = null, $provincia = null, $sezione = null)
    {
        $this
            ->setCodiceComune($codiceComune)
            ->setFoglio($foglio)
            ->setFormatoMappa($formatoMappa)
            ->setInteroFoglio($interoFoglio)
            ->setMappeLimitrofe($mappeLimitrofe)
            ->setParticella($particella)
            ->setProvincia($provincia)
            ->setSezione($sezione);
    }
    /**
     * Get codiceComune value
     * @return string|null
     */
    public function getCodiceComune()
    {
        return $this->codiceComune;
    }
    /**
     * Set codiceComune value
     * @param string $codiceComune
     * @return \Sisteract\StructType\ParametriEstrattoMappa_Type
     */
    public function setCodiceComune($codiceComune = null)
    {
        // validation for constraint: string
        if (!is_null($codiceComune) && !is_string($codiceComune)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codiceComune, true), gettype($codiceComune)), __LINE__);
        }
        $this->codiceComune = $codiceComune;
        return $this;
    }
    /**
     * Get foglio value
     * @return string|null
     */
    public function getFoglio()
    {
        return $this->foglio;
    }
    /**
     * Set foglio value
     * @param string $foglio
     * @return \Sisteract\StructType\ParametriEstrattoMappa_Type
     */
    public function setFoglio($foglio = null)
    {
        // validation for constraint: string
        if (!is_null($foglio) && !is_string($foglio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($foglio, true), gettype($foglio)), __LINE__);
        }
        $this->foglio = $foglio;
        return $this;
    }
    /**
     * Get formatoMappa value
     * @return string|null
     */
    public function getFormatoMappa()
    {
        return $this->formatoMappa;
    }
    /**
     * Set formatoMappa value
     * @uses \Sisteract\EnumType\EnumFormatoMappa_Type::valueIsValid()
     * @uses \Sisteract\EnumType\EnumFormatoMappa_Type::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $formatoMappa
     * @return \Sisteract\StructType\ParametriEstrattoMappa_Type
     */
    public function setFormatoMappa($formatoMappa = null)
    {
        // validation for constraint: enumeration
        if (!\Sisteract\EnumType\EnumFormatoMappa_Type::valueIsValid($formatoMappa)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Sisteract\EnumType\EnumFormatoMappa_Type', is_array($formatoMappa) ? implode(', ', $formatoMappa) : var_export($formatoMappa, true), implode(', ', \Sisteract\EnumType\EnumFormatoMappa_Type::getValidValues())), __LINE__);
        }
        $this->formatoMappa = $formatoMappa;
        return $this;
    }
    /**
     * Get interoFoglio value
     * @return bool|null
     */
    public function getInteroFoglio()
    {
        return $this->interoFoglio;
    }
    /**
     * Set interoFoglio value
     * @param bool $interoFoglio
     * @return \Sisteract\StructType\ParametriEstrattoMappa_Type
     */
    public function setInteroFoglio($interoFoglio = null)
    {
        // validation for constraint: boolean
        if (!is_null($interoFoglio) && !is_bool($interoFoglio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($interoFoglio, true), gettype($interoFoglio)), __LINE__);
        }
        $this->interoFoglio = $interoFoglio;
        return $this;
    }
    /**
     * Get mappeLimitrofe value
     * @return bool|null
     */
    public function getMappeLimitrofe()
    {
        return $this->mappeLimitrofe;
    }
    /**
     * Set mappeLimitrofe value
     * @param bool $mappeLimitrofe
     * @return \Sisteract\StructType\ParametriEstrattoMappa_Type
     */
    public function setMappeLimitrofe($mappeLimitrofe = null)
    {
        // validation for constraint: boolean
        if (!is_null($mappeLimitrofe) && !is_bool($mappeLimitrofe)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($mappeLimitrofe, true), gettype($mappeLimitrofe)), __LINE__);
        }
        $this->mappeLimitrofe = $mappeLimitrofe;
        return $this;
    }
    /**
     * Get particella value
     * @return string|null
     */
    public function getParticella()
    {
        return $this->particella;
    }
    /**
     * Set particella value
     * @param string $particella
     * @return \Sisteract\StructType\ParametriEstrattoMappa_Type
     */
    public function setParticella($particella = null)
    {
        // validation for constraint: string
        if (!is_null($particella) && !is_string($particella)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($particella, true), gettype($particella)), __LINE__);
        }
        $this->particella = $particella;
        return $this;
    }
    /**
     * Get provincia value
     * @return string|null
     */
    public function getProvincia()
    {
        return $this->provincia;
    }
    /**
     * Set provincia value
     * @param string $provincia
     * @return \Sisteract\StructType\ParametriEstrattoMappa_Type
     */
    public function setProvincia($provincia = null)
    {
        // validation for constraint: string
        if (!is_null($provincia) && !is_string($provincia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($provincia, true), gettype($provincia)), __LINE__);
        }
        $this->provincia = $provincia;
        return $this;
    }
    /**
     * Get sezione value
     * @return string|null
     */
    public function getSezione()
    {
        return $this->sezione;
    }
    /**
     * Set sezione value
     * @param string $sezione
     * @return \Sisteract\StructType\ParametriEstrattoMappa_Type
     */
    public function setSezione($sezione = null)
    {
        // validation for constraint: string
        if (!is_null($sezione) && !is_string($sezione)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sezione, true), gettype($sezione)), __LINE__);
        }
        $this->sezione = $sezione;
        return $this;
    }
}
