<?php

namespace Sisteract\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ParametriRicercaComuni_Type StructType
 * Meta information extracted from the WSDL
 * - documentation: Bean dei parametri per la ricerca dei comuni di un id persona su cui ha dei beni.
 * @subpackage Structs
 */
class ParametriRicercaComuni_Type extends Session_Type
{
    /**
     * The idSoggetto
     * Meta information extracted from the WSDL
     * - documentation: Id del soggetto di cui si vogliono avere i comuni, su cui sono i beni
     * - nillable: true
     * @var string
     */
    public $idSoggetto;
    /**
     * Constructor method for ParametriRicercaComuni_Type
     * @uses ParametriRicercaComuni_Type::setIdSoggetto()
     * @param string $idSoggetto
     */
    public function __construct($idSoggetto = null)
    {
        $this
            ->setIdSoggetto($idSoggetto);
    }
    /**
     * Get idSoggetto value
     * @return string|null
     */
    public function getIdSoggetto()
    {
        return $this->idSoggetto;
    }
    /**
     * Set idSoggetto value
     * @param string $idSoggetto
     * @return \Sisteract\StructType\ParametriRicercaComuni_Type
     */
    public function setIdSoggetto($idSoggetto = null)
    {
        // validation for constraint: string
        if (!is_null($idSoggetto) && !is_string($idSoggetto)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($idSoggetto, true), gettype($idSoggetto)), __LINE__);
        }
        $this->idSoggetto = $idSoggetto;
        return $this;
    }
}
