<?php

namespace Sisteract\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ParametriRichiestaVisuraImmobili_Type StructType
 * Meta information extracted from the WSDL
 * - documentation: Bean dei parametri per ricevere le visure Immobili.Questo bean definisce il tipo di visura che si vuole ottenere e seLa visura puo' essere richiesta in differita.
 * @subpackage Structs
 */
class ParametriRichiestaVisuraImmobili_Type extends Session_Type
{
    /**
     * The differita
     * Meta information extracted from the WSDL
     * - documentation: Definisce se la visura deve essere richiesta in differitaTRUE=differitaFALSE=On line
     * @var bool
     */
    public $differita;
    /**
     * The tipoVisura
     * Meta information extracted from the WSDL
     * - documentation: Il tipo di visura immobile che si vuole ottenere, il valore passato deve esserenella lista di quelli ritornati nell prcedente chiamata: getRichiestaTipiVisuraImmobilevalori
     * ammessi:VISURA_IMMOBILE_SINTETICAVISURA_IMMOBILE_COMPLETAVISURA_IMMOBILE_STORICAVISURA_IMMOBILE_PARTITA parametro mandatario
     * - nillable: true
     * @var string
     */
    public $tipoVisura;
    /**
     * Constructor method for ParametriRichiestaVisuraImmobili_Type
     * @uses ParametriRichiestaVisuraImmobili_Type::setDifferita()
     * @uses ParametriRichiestaVisuraImmobili_Type::setTipoVisura()
     * @param bool $differita
     * @param string $tipoVisura
     */
    public function __construct($differita = null, $tipoVisura = null)
    {
        $this
            ->setDifferita($differita)
            ->setTipoVisura($tipoVisura);
    }
    /**
     * Get differita value
     * @return bool|null
     */
    public function getDifferita()
    {
        return $this->differita;
    }
    /**
     * Set differita value
     * @param bool $differita
     * @return \Sisteract\StructType\ParametriRichiestaVisuraImmobili_Type
     */
    public function setDifferita($differita = null)
    {
        // validation for constraint: boolean
        if (!is_null($differita) && !is_bool($differita)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($differita, true), gettype($differita)), __LINE__);
        }
        $this->differita = $differita;
        return $this;
    }
    /**
     * Get tipoVisura value
     * @return string|null
     */
    public function getTipoVisura()
    {
        return $this->tipoVisura;
    }
    /**
     * Set tipoVisura value
     * @uses \Sisteract\EnumType\EnumTipoVisura_Type::valueIsValid()
     * @uses \Sisteract\EnumType\EnumTipoVisura_Type::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $tipoVisura
     * @return \Sisteract\StructType\ParametriRichiestaVisuraImmobili_Type
     */
    public function setTipoVisura($tipoVisura = null)
    {
        // validation for constraint: enumeration
        if (!\Sisteract\EnumType\EnumTipoVisura_Type::valueIsValid($tipoVisura)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Sisteract\EnumType\EnumTipoVisura_Type', is_array($tipoVisura) ? implode(', ', $tipoVisura) : var_export($tipoVisura, true), implode(', ', \Sisteract\EnumType\EnumTipoVisura_Type::getValidValues())), __LINE__);
        }
        $this->tipoVisura = $tipoVisura;
        return $this;
    }
}
