<?php

namespace Sisteract\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReturnElencoImmobiliList_Type StructType
 * Meta information extracted from the WSDL
 * - documentation: Bean di risposta che riporta l'elenco degli immobili su una provincia dove una personafisica o giuridica, possiede dei terreni o dei fabbricati
 * @subpackage Structs
 */
class ReturnElencoImmobiliList_Type extends Session_Type
{
    /**
     * The listImmobiliDaElencoBean
     * Meta information extracted from the WSDL
     * - documentation: Lista degli immobili trovati
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Sisteract\StructType\ImmobileDaElencoBean_Type[]
     */
    public $listImmobiliDaElencoBean;
    /**
     * Constructor method for ReturnElencoImmobiliList_Type
     * @uses ReturnElencoImmobiliList_Type::setListImmobiliDaElencoBean()
     * @param \Sisteract\StructType\ImmobileDaElencoBean_Type[] $listImmobiliDaElencoBean
     */
    public function __construct(array $listImmobiliDaElencoBean = array())
    {
        $this
            ->setListImmobiliDaElencoBean($listImmobiliDaElencoBean);
    }
    /**
     * Get listImmobiliDaElencoBean value
     * @return \Sisteract\StructType\ImmobileDaElencoBean_Type[]|null
     */
    public function getListImmobiliDaElencoBean()
    {
        return $this->listImmobiliDaElencoBean;
    }
    /**
     * This method is responsible for validating the values passed to the setListImmobiliDaElencoBean method
     * This method is willingly generated in order to preserve the one-line inline validation within the setListImmobiliDaElencoBean method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateListImmobiliDaElencoBeanForArrayConstraintsFromSetListImmobiliDaElencoBean(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $returnElencoImmobiliList_TypeListImmobiliDaElencoBeanItem) {
            // validation for constraint: itemType
            if (!$returnElencoImmobiliList_TypeListImmobiliDaElencoBeanItem instanceof \Sisteract\StructType\ImmobileDaElencoBean_Type) {
                $invalidValues[] = is_object($returnElencoImmobiliList_TypeListImmobiliDaElencoBeanItem) ? get_class($returnElencoImmobiliList_TypeListImmobiliDaElencoBeanItem) : sprintf('%s(%s)', gettype($returnElencoImmobiliList_TypeListImmobiliDaElencoBeanItem), var_export($returnElencoImmobiliList_TypeListImmobiliDaElencoBeanItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The listImmobiliDaElencoBean property can only contain items of type \Sisteract\StructType\ImmobileDaElencoBean_Type, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set listImmobiliDaElencoBean value
     * @throws \InvalidArgumentException
     * @param \Sisteract\StructType\ImmobileDaElencoBean_Type[] $listImmobiliDaElencoBean
     * @return \Sisteract\StructType\ReturnElencoImmobiliList_Type
     */
    public function setListImmobiliDaElencoBean(array $listImmobiliDaElencoBean = array())
    {
        // validation for constraint: array
        if ('' !== ($listImmobiliDaElencoBeanArrayErrorMessage = self::validateListImmobiliDaElencoBeanForArrayConstraintsFromSetListImmobiliDaElencoBean($listImmobiliDaElencoBean))) {
            throw new \InvalidArgumentException($listImmobiliDaElencoBeanArrayErrorMessage, __LINE__);
        }
        $this->listImmobiliDaElencoBean = $listImmobiliDaElencoBean;
        return $this;
    }
    /**
     * Add item to listImmobiliDaElencoBean value
     * @throws \InvalidArgumentException
     * @param \Sisteract\StructType\ImmobileDaElencoBean_Type $item
     * @return \Sisteract\StructType\ReturnElencoImmobiliList_Type
     */
    public function addToListImmobiliDaElencoBean(\Sisteract\StructType\ImmobileDaElencoBean_Type $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sisteract\StructType\ImmobileDaElencoBean_Type) {
            throw new \InvalidArgumentException(sprintf('The listImmobiliDaElencoBean property can only contain items of type \Sisteract\StructType\ImmobileDaElencoBean_Type, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->listImmobiliDaElencoBean[] = $item;
        return $this;
    }
}
