<?php

namespace Sisteract\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReturnElencoIntestatiList_Type StructType
 * @subpackage Structs
 */
class ReturnElencoIntestatiList_Type extends AbstractStructBase
{
    /**
     * The listIntestatiDaElencoBean
     * Meta information extracted from the WSDL
     * - documentation: Lita degli Intestati di un determinato immobile
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Sisteract\StructType\IntestatiDaElencoBean_Type[]
     */
    public $listIntestatiDaElencoBean;
    /**
     * Constructor method for ReturnElencoIntestatiList_Type
     * @uses ReturnElencoIntestatiList_Type::setListIntestatiDaElencoBean()
     * @param \Sisteract\StructType\IntestatiDaElencoBean_Type[] $listIntestatiDaElencoBean
     */
    public function __construct(array $listIntestatiDaElencoBean = array())
    {
        $this
            ->setListIntestatiDaElencoBean($listIntestatiDaElencoBean);
    }
    /**
     * Get listIntestatiDaElencoBean value
     * @return \Sisteract\StructType\IntestatiDaElencoBean_Type[]|null
     */
    public function getListIntestatiDaElencoBean()
    {
        return $this->listIntestatiDaElencoBean;
    }
    /**
     * This method is responsible for validating the values passed to the setListIntestatiDaElencoBean method
     * This method is willingly generated in order to preserve the one-line inline validation within the setListIntestatiDaElencoBean method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateListIntestatiDaElencoBeanForArrayConstraintsFromSetListIntestatiDaElencoBean(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $returnElencoIntestatiList_TypeListIntestatiDaElencoBeanItem) {
            // validation for constraint: itemType
            if (!$returnElencoIntestatiList_TypeListIntestatiDaElencoBeanItem instanceof \Sisteract\StructType\IntestatiDaElencoBean_Type) {
                $invalidValues[] = is_object($returnElencoIntestatiList_TypeListIntestatiDaElencoBeanItem) ? get_class($returnElencoIntestatiList_TypeListIntestatiDaElencoBeanItem) : sprintf('%s(%s)', gettype($returnElencoIntestatiList_TypeListIntestatiDaElencoBeanItem), var_export($returnElencoIntestatiList_TypeListIntestatiDaElencoBeanItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The listIntestatiDaElencoBean property can only contain items of type \Sisteract\StructType\IntestatiDaElencoBean_Type, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set listIntestatiDaElencoBean value
     * @throws \InvalidArgumentException
     * @param \Sisteract\StructType\IntestatiDaElencoBean_Type[] $listIntestatiDaElencoBean
     * @return \Sisteract\StructType\ReturnElencoIntestatiList_Type
     */
    public function setListIntestatiDaElencoBean(array $listIntestatiDaElencoBean = array())
    {
        // validation for constraint: array
        if ('' !== ($listIntestatiDaElencoBeanArrayErrorMessage = self::validateListIntestatiDaElencoBeanForArrayConstraintsFromSetListIntestatiDaElencoBean($listIntestatiDaElencoBean))) {
            throw new \InvalidArgumentException($listIntestatiDaElencoBeanArrayErrorMessage, __LINE__);
        }
        $this->listIntestatiDaElencoBean = $listIntestatiDaElencoBean;
        return $this;
    }
    /**
     * Add item to listIntestatiDaElencoBean value
     * @throws \InvalidArgumentException
     * @param \Sisteract\StructType\IntestatiDaElencoBean_Type $item
     * @return \Sisteract\StructType\ReturnElencoIntestatiList_Type
     */
    public function addToListIntestatiDaElencoBean(\Sisteract\StructType\IntestatiDaElencoBean_Type $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sisteract\StructType\IntestatiDaElencoBean_Type) {
            throw new \InvalidArgumentException(sprintf('The listIntestatiDaElencoBean property can only contain items of type \Sisteract\StructType\IntestatiDaElencoBean_Type, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->listIntestatiDaElencoBean[] = $item;
        return $this;
    }
}
