<?php

namespace Sisteract\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReturnIdentificativoCatastaleList_Type StructType
 * Meta information extracted from the WSDL
 * - documentation: Bean di ritorno, della lista degli identificativi degli immobili trovatiTorna se la ricerca non e' negativa (campo isRitornatoValori) una lista divalori che identioficano catastalmente tutti gli immobili trovati.Questi dati sono
 * necessari per ottenre la visura immobile.
 * @subpackage Structs
 */
class ReturnIdentificativoCatastaleList_Type extends Session_Type
{
    /**
     * The listIdentificativoCatastaleBean
     * Meta information extracted from the WSDL
     * - documentation: Lista degli identificativi trovati
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Sisteract\StructType\IdentificativoCatastaleBean_Type[]
     */
    public $listIdentificativoCatastaleBean;
    /**
     * The ritornatoValori
     * Meta information extracted from the WSDL
     * - documentation: Definisce se e' stato trovato un identificativo o la ricerca e' tornata negativaTRUE=Identificativi trovatiFALSE=Ricerca negativa
     * @var bool
     */
    public $ritornatoValori;
    /**
     * Constructor method for ReturnIdentificativoCatastaleList_Type
     * @uses ReturnIdentificativoCatastaleList_Type::setListIdentificativoCatastaleBean()
     * @uses ReturnIdentificativoCatastaleList_Type::setRitornatoValori()
     * @param \Sisteract\StructType\IdentificativoCatastaleBean_Type[] $listIdentificativoCatastaleBean
     * @param bool $ritornatoValori
     */
    public function __construct(array $listIdentificativoCatastaleBean = array(), $ritornatoValori = null)
    {
        $this
            ->setListIdentificativoCatastaleBean($listIdentificativoCatastaleBean)
            ->setRitornatoValori($ritornatoValori);
    }
    /**
     * Get listIdentificativoCatastaleBean value
     * @return \Sisteract\StructType\IdentificativoCatastaleBean_Type[]|null
     */
    public function getListIdentificativoCatastaleBean()
    {
        return $this->listIdentificativoCatastaleBean;
    }
    /**
     * This method is responsible for validating the values passed to the setListIdentificativoCatastaleBean method
     * This method is willingly generated in order to preserve the one-line inline validation within the setListIdentificativoCatastaleBean method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateListIdentificativoCatastaleBeanForArrayConstraintsFromSetListIdentificativoCatastaleBean(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $returnIdentificativoCatastaleList_TypeListIdentificativoCatastaleBeanItem) {
            // validation for constraint: itemType
            if (!$returnIdentificativoCatastaleList_TypeListIdentificativoCatastaleBeanItem instanceof \Sisteract\StructType\IdentificativoCatastaleBean_Type) {
                $invalidValues[] = is_object($returnIdentificativoCatastaleList_TypeListIdentificativoCatastaleBeanItem) ? get_class($returnIdentificativoCatastaleList_TypeListIdentificativoCatastaleBeanItem) : sprintf('%s(%s)', gettype($returnIdentificativoCatastaleList_TypeListIdentificativoCatastaleBeanItem), var_export($returnIdentificativoCatastaleList_TypeListIdentificativoCatastaleBeanItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The listIdentificativoCatastaleBean property can only contain items of type \Sisteract\StructType\IdentificativoCatastaleBean_Type, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set listIdentificativoCatastaleBean value
     * @throws \InvalidArgumentException
     * @param \Sisteract\StructType\IdentificativoCatastaleBean_Type[] $listIdentificativoCatastaleBean
     * @return \Sisteract\StructType\ReturnIdentificativoCatastaleList_Type
     */
    public function setListIdentificativoCatastaleBean(array $listIdentificativoCatastaleBean = array())
    {
        // validation for constraint: array
        if ('' !== ($listIdentificativoCatastaleBeanArrayErrorMessage = self::validateListIdentificativoCatastaleBeanForArrayConstraintsFromSetListIdentificativoCatastaleBean($listIdentificativoCatastaleBean))) {
            throw new \InvalidArgumentException($listIdentificativoCatastaleBeanArrayErrorMessage, __LINE__);
        }
        $this->listIdentificativoCatastaleBean = $listIdentificativoCatastaleBean;
        return $this;
    }
    /**
     * Add item to listIdentificativoCatastaleBean value
     * @throws \InvalidArgumentException
     * @param \Sisteract\StructType\IdentificativoCatastaleBean_Type $item
     * @return \Sisteract\StructType\ReturnIdentificativoCatastaleList_Type
     */
    public function addToListIdentificativoCatastaleBean(\Sisteract\StructType\IdentificativoCatastaleBean_Type $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sisteract\StructType\IdentificativoCatastaleBean_Type) {
            throw new \InvalidArgumentException(sprintf('The listIdentificativoCatastaleBean property can only contain items of type \Sisteract\StructType\IdentificativoCatastaleBean_Type, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->listIdentificativoCatastaleBean[] = $item;
        return $this;
    }
    /**
     * Get ritornatoValori value
     * @return bool|null
     */
    public function getRitornatoValori()
    {
        return $this->ritornatoValori;
    }
    /**
     * Set ritornatoValori value
     * @param bool $ritornatoValori
     * @return \Sisteract\StructType\ReturnIdentificativoCatastaleList_Type
     */
    public function setRitornatoValori($ritornatoValori = null)
    {
        // validation for constraint: boolean
        if (!is_null($ritornatoValori) && !is_bool($ritornatoValori)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($ritornatoValori, true), gettype($ritornatoValori)), __LINE__);
        }
        $this->ritornatoValori = $ritornatoValori;
        return $this;
    }
}
