<?php

namespace Sisteract\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReturnProvincieList_Type StructType
 * Meta information extracted from the WSDL
 * - documentation: Bean di risposta che riporta la lista dei comuni trovati dove una personafisica o giuridica, possiedono dei terreni o dei fabbricati
 * @subpackage Structs
 */
class ReturnProvincieList_Type extends Session_Type
{
    /**
     * The listProvincieTerreniFabbricatiBean
     * Meta information extracted from the WSDL
     * - documentation: Lista dei Comuni troviati. Nel caso il sister risponda che "non ce l'ho fatta a rispondere nel tempo previsto..." può tornare lunghezza 0
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Sisteract\StructType\ProvinciaTerreniFabbricatiBean_Type[]
     */
    public $listProvincieTerreniFabbricatiBean;
    /**
     * Constructor method for ReturnProvincieList_Type
     * @uses ReturnProvincieList_Type::setListProvincieTerreniFabbricatiBean()
     * @param \Sisteract\StructType\ProvinciaTerreniFabbricatiBean_Type[] $listProvincieTerreniFabbricatiBean
     */
    public function __construct(array $listProvincieTerreniFabbricatiBean = array())
    {
        $this
            ->setListProvincieTerreniFabbricatiBean($listProvincieTerreniFabbricatiBean);
    }
    /**
     * Get listProvincieTerreniFabbricatiBean value
     * @return \Sisteract\StructType\ProvinciaTerreniFabbricatiBean_Type[]|null
     */
    public function getListProvincieTerreniFabbricatiBean()
    {
        return $this->listProvincieTerreniFabbricatiBean;
    }
    /**
     * This method is responsible for validating the values passed to the setListProvincieTerreniFabbricatiBean method
     * This method is willingly generated in order to preserve the one-line inline validation within the setListProvincieTerreniFabbricatiBean method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateListProvincieTerreniFabbricatiBeanForArrayConstraintsFromSetListProvincieTerreniFabbricatiBean(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $returnProvincieList_TypeListProvincieTerreniFabbricatiBeanItem) {
            // validation for constraint: itemType
            if (!$returnProvincieList_TypeListProvincieTerreniFabbricatiBeanItem instanceof \Sisteract\StructType\ProvinciaTerreniFabbricatiBean_Type) {
                $invalidValues[] = is_object($returnProvincieList_TypeListProvincieTerreniFabbricatiBeanItem) ? get_class($returnProvincieList_TypeListProvincieTerreniFabbricatiBeanItem) : sprintf('%s(%s)', gettype($returnProvincieList_TypeListProvincieTerreniFabbricatiBeanItem), var_export($returnProvincieList_TypeListProvincieTerreniFabbricatiBeanItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The listProvincieTerreniFabbricatiBean property can only contain items of type \Sisteract\StructType\ProvinciaTerreniFabbricatiBean_Type, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set listProvincieTerreniFabbricatiBean value
     * @throws \InvalidArgumentException
     * @param \Sisteract\StructType\ProvinciaTerreniFabbricatiBean_Type[] $listProvincieTerreniFabbricatiBean
     * @return \Sisteract\StructType\ReturnProvincieList_Type
     */
    public function setListProvincieTerreniFabbricatiBean(array $listProvincieTerreniFabbricatiBean = array())
    {
        // validation for constraint: array
        if ('' !== ($listProvincieTerreniFabbricatiBeanArrayErrorMessage = self::validateListProvincieTerreniFabbricatiBeanForArrayConstraintsFromSetListProvincieTerreniFabbricatiBean($listProvincieTerreniFabbricatiBean))) {
            throw new \InvalidArgumentException($listProvincieTerreniFabbricatiBeanArrayErrorMessage, __LINE__);
        }
        $this->listProvincieTerreniFabbricatiBean = $listProvincieTerreniFabbricatiBean;
        return $this;
    }
    /**
     * Add item to listProvincieTerreniFabbricatiBean value
     * @throws \InvalidArgumentException
     * @param \Sisteract\StructType\ProvinciaTerreniFabbricatiBean_Type $item
     * @return \Sisteract\StructType\ReturnProvincieList_Type
     */
    public function addToListProvincieTerreniFabbricatiBean(\Sisteract\StructType\ProvinciaTerreniFabbricatiBean_Type $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sisteract\StructType\ProvinciaTerreniFabbricatiBean_Type) {
            throw new \InvalidArgumentException(sprintf('The listProvincieTerreniFabbricatiBean property can only contain items of type \Sisteract\StructType\ProvinciaTerreniFabbricatiBean_Type, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->listProvincieTerreniFabbricatiBean[] = $item;
        return $this;
    }
}
